找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 880|回复: 0

[分享] Create field by picked point coordinate

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 03:05:30 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
       [CommandMethod("FieldPointLocation", "fpl", CommandFlags.Redraw | CommandFlags.Modal)]
        public static void SetField()
        {

            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Database db = doc.Database;
            Editor ed = doc.Editor;
            // Set snap to whatever you need:
            //  Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("osmode", 1);
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                Point3d pt = ed.GetPoint("\nPick field location: ").Value;
                Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("lastpoint", pt);
                Field fieldobj = new Field();
                fieldobj.EvaluationOption = FieldEvaluationOptions.Automatic;
                fieldobj.SetFieldCode("%<\\AcVar lastpoint \\f \"%lu2%pt3%ls59%pr3\">%");// decimal, separator semicolon,presicion 3
                //fieldobj.SetFieldCode("%<\\AcVar lastpoint \\f \"%lu4%pt3\">%");// architectural, separator comma, precision 1/8"
                MText mtextobj = new MText();
                mtextobj.SetDatabaseDefaults();
                mtextobj.SetField("Text", fieldobj);
                fieldobj.Evaluate(0, db);
                mtextobj.Location = pt;
                BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
                btr.AppendEntity(mtextobj);
                tr.AddNewlyCreatedDBObject(mtextobj, true);
                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-5-16 02:57 , Processed in 0.349475 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表